<?php
class ControllerextensionModuleevaluation extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/evaluation');

		$this->document->setTitle(preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')));

		$this->load->model('extension/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_extension_module->addModule('evaluation', $this->request->post);
			} else {
				$this->model_extension_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
		}

		$data['heading_title'] = preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title'));

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_mainc'] = $this->language->get('text_mainc');
		$data['text_mainfw'] = $this->language->get('text_mainfw');
		
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_image'] = $this->language->get('entry_image');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_titlename'] = $this->language->get('entry_titlename');
		$data['entry_bgcolortitle'] = $this->language->get('entry_bgcolortitle');
		$data['entry_bgcolor'] = $this->language->get('entry_bgcolor');
		$data['entry_bgcolorcss'] = $this->language->get('entry_bgcolorcss');
		$data['entry_positioncss'] = $this->language->get('entry_positioncss');
		$data['entry_titlejbcss'] = $this->language->get('entry_titlejbcss');
		$data['entry_titlejbsmcss'] = $this->language->get('entry_titlejbsmcss');
		$data['entry_titlecss'] = $this->language->get('entry_titlecss');
		$data['entry_titlesmcss'] = $this->language->get('entry_titlesmcss');
		$data['entry_describe'] = $this->language->get('entry_describe');
		$data['entry_title'] = $this->language->get('entry_title');
		$data['entry_other'] = $this->language->get('entry_other');
		$data['entry_text'] = $this->language->get('entry_text');
		$data['entry_link'] = $this->language->get('entry_link');
		$data['entry_image'] = $this->language->get('entry_image');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_eocss'] = $this->language->get('entry_eocss');
		$data['entry_etncolor'] = $this->language->get('entry_etncolor');
		$data['entry_edcolor'] = $this->language->get('entry_edcolor');
		$data['entry_eotop'] = $this->language->get('entry_eotop');
		$data['entry_eob'] = $this->language->get('entry_eob');
		$data['entry_column'] = $this->language->get('entry_column');
		$data['help_column'] = $this->language->get('help_column');
		$data['entry_segmentingline'] = $this->language->get('entry_segmentingline');
		$data['entry_etlinew'] = $this->language->get('entry_etlinew');
		$data['entry_etlineh'] = $this->language->get('entry_etlineh');
		$data['entry_etlinec'] = $this->language->get('entry_etlinec');
		$data['entry_autoplay'] = $this->language->get('entry_autoplay');
		$data['entry_main'] = $this->language->get('entry_main');
		$data['entry_speed'] = $this->language->get('entry_speed');
		$data['entry_fade'] = $this->language->get('entry_fade');
		$data['entry_imgmm'] = $this->language->get('entry_imgmm');
		$data['entry_imground'] = $this->language->get('entry_imground');        
		$data['entry_imgthumb'] = $this->language->get('entry_imgthumb');	
		$data['entry_imgshadow'] = $this->language->get('entry_imgshadow');
		$data['entry_imgpadding'] = $this->language->get('entry_imgpadding');        
		$data['entry_imgborder'] = $this->language->get('entry_imgborder');	
		$data['entry_imgcolor'] = $this->language->get('entry_imgcolor');
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_add'] = $this->language->get('button_add');
		$data['button_remove'] = $this->language->get('button_remove');

		$data['error_name'] = $this->language->get('error_name');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}
		if (isset($this->error['column'])) {
			$data['error_column'] = $this->error['column'];
		} else {
			$data['error_column'] = '';
		}
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')),
			'href' => $this->url->link('extension/module/evaluation', 'token=' . $this->session->data['token'], 'SSL')
		);

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('extension/module/evaluation', 'token=' . $this->session->data['token'], 'SSL');
		} else {
			$data['action'] = $this->url->link('extension/module/evaluation', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL');
		}

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_extension_module->getModule($this->request->get['module_id']);
		}

		$data['token'] = $this->session->data['token'];

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}
		if (isset($this->request->post['titlename'])) {
			$data['titlename'] = $this->request->post['titlename'];
		} elseif (!empty($module_info)) {
			$data['titlename'] = $module_info['titlename'];
		} else {
			$data['titlename'] = '';
		}
		$this->load->model('tool/image');

		if (isset($this->request->post['image'])) {
			$data['image'] = $this->request->post['image'];
		} elseif (isset($module_info['image'])) {
			$data['image'] = $module_info['image'];
		} else {
			$data['image'] = '';
		}

		if (is_file(DIR_IMAGE . $data['image'])) {
			$thumb = $data['image'];
		} else {
			$thumb = 'no_image.png';
		}

		$data['thumb'] = $this->model_tool_image->resize($thumb, 100, 100);

		if (isset($this->request->post['width'])) {
			$data['width'] = $this->request->post['width'];
		} elseif (!empty($module_info)) {
			$data['width'] = $module_info['width'];
		} else {
			$data['width'] = '1600';
		}

		if (isset($this->request->post['height'])) {
			$data['height'] = $this->request->post['height'];
		} elseif (!empty($module_info)) {
			$data['height'] = $module_info['height'];
		} else {
			$data['height'] = '750';
		}
		if (isset($this->request->post['bgcolor'])) {
			$data['bgcolor'] = $this->request->post['bgcolor'];
		} elseif (!empty($module_info)) {
			$data['bgcolor'] = $module_info['bgcolor'];
		} else {
			$data['bgcolor'] = '';
		}
		if (isset($this->request->post['bgcolorcss'])) {
			$data['bgcolorcss'] = $this->request->post['bgcolorcss'];
		} elseif (!empty($module_info)) {
			$data['bgcolorcss'] = $module_info['bgcolorcss'];
		} else {
			$data['bgcolorcss'] = '';
		}
		if (isset($this->request->post['titlecss'])) {
			$data['titlecss'] = $this->request->post['titlecss'];
		} elseif (!empty($module_info)) {
			$data['titlecss'] = $module_info['titlecss'];
		} else {
			$data['titlecss'] = '';
		}		
		if (isset($this->request->post['titlesmcss'])) {
			$data['titlesmcss'] = $this->request->post['titlesmcss'];
		} elseif (!empty($module_info)) {
			$data['titlesmcss'] = $module_info['titlesmcss'];
		} else {
			$data['titlesmcss'] = '';
		}
		if (isset($this->request->post['positioncss'])) {
			$data['positioncss'] = $this->request->post['positioncss'];
		} elseif (!empty($module_info)) {
			$data['positioncss'] = $module_info['positioncss'];
		} else {
			$data['positioncss'] = '';
		}
		if (isset($this->request->post['describe'])) {
			$data['describe'] = $this->request->post['describe'];
		} elseif (!empty($module_info)) {
			$data['describe'] = $module_info['describe'];
		} else {
			$data['describe'] = '';
		}
		if (isset($this->request->post['etncolor'])) {
			$data['etncolor'] = $this->request->post['etncolor'];
		} elseif (!empty($module_info)) {
			$data['etncolor'] = $module_info['etncolor'];
		} else {
			$data['etncolor'] = '';
		}
		if (isset($this->request->post['edcolor'])) {
			$data['edcolor'] = $this->request->post['edcolor'];
		} elseif (!empty($module_info)) {
			$data['edcolor'] = $module_info['edcolor'];
		} else {
			$data['edcolor'] = '';
		}
		if (isset($this->request->post['eotop'])) {
			$data['eotop'] = $this->request->post['eotop'];
		} elseif (!empty($module_info)) {
			$data['eotop'] = $module_info['eotop'];
		} else {
			$data['eotop'] = '70';
		}
		if (isset($this->request->post['eob'])) {
			$data['eob'] = $this->request->post['eob'];
		} elseif (!empty($module_info)) {
			$data['eob'] = $module_info['eob'];
		} else {
			$data['eob'] = '70';
		}
		if (isset($this->request->post['column'])) {
			$data['column'] = $this->request->post['column'];
		} elseif (!empty($module_info)) {
			$data['column'] = $module_info['column'];
		} else {
			$data['column'] = '7';
		}
		if (isset($this->request->post['etlinew'])) {
			$data['etlinew'] = $this->request->post['etlinew'];
		} elseif (!empty($module_info)) {
			$data['etlinew'] = $module_info['etlinew'];
		} else {
			$data['etlinew'] = '';
		}
		if (isset($this->request->post['etlineh'])) {
			$data['etlineh'] = $this->request->post['etlineh'];
		} elseif (!empty($module_info)) {
			$data['etlineh'] = $module_info['etlineh'];
		} else {
			$data['etlineh'] = '';
		}
		if (isset($this->request->post['etlinec'])) {
			$data['etlinec'] = $this->request->post['etlinec'];
		} elseif (!empty($module_info)) {
			$data['etlinec'] = $module_info['etlinec'];
		} else {
			$data['etlinec'] = '';
		}
		if (isset($this->request->post['autoplay'])) {
			$data['autoplay'] = $this->request->post['autoplay'];
		} elseif (!empty($module_info)) {
			$data['autoplay'] = $module_info['autoplay'];
		} else {
			$data['autoplay'] = '';
		}
		if (isset($this->request->post['main'])) {
			$data['main'] = $this->request->post['main'];
		} elseif (!empty($module_info)) {
			$data['main'] = $module_info['main'];
		} else {
			$data['main'] = '';
		}
		if (isset($this->request->post['speed'])) {
			$data['speed'] = $this->request->post['speed'];
		} elseif (!empty($module_info)) {
			$data['speed'] = $module_info['speed'];
		} else {
			$data['speed'] = '3000';
		} 
		if (isset($this->request->post['fade'])) {
			$data['fade'] = $this->request->post['fade'];
		} elseif (!empty($module_info)) {
			$data['fade'] = $module_info['fade'];
		} else {
			$data['fade'] = '';
		}
		if (isset($this->request->post['imground'])) {
			$data['imground'] = $this->request->post['imground'];
		} elseif (!empty($module_info)) {
			$data['imground'] = $module_info['imground'];
		} else {
			$data['imground'] = '50';
		}
		if (isset($this->request->post['imgthumb'])) {
			$data['imgthumb'] = $this->request->post['imgthumb'];
		} elseif (!empty($module_info)) {
			$data['imgthumb'] = $module_info['imgthumb'];
		} else {
			$data['imgthumb'] = 'img-thumbnail';
		}
		if (isset($this->request->post['imgshadow'])) {
			$data['imgshadow'] = $this->request->post['imgshadow'];
		} elseif (!empty($module_info)) {
			$data['imgshadow'] = $module_info['imgshadow'];
		} else {
			$data['imgshadow'] = '29';
		}
		if (isset($this->request->post['imgpadding'])) {
			$data['imgpadding'] = $this->request->post['imgpadding'];
		} elseif (!empty($module_info)) {
			$data['imgpadding'] = $module_info['imgpadding'];
		} else {
			$data['imgpadding'] = '0';
		}
		if (isset($this->request->post['imgborder'])) {
			$data['imgborder'] = $this->request->post['imgborder'];
		} elseif (!empty($module_info)) {
			$data['imgborder'] = $module_info['imgborder'];
		} else {
			$data['imgborder'] = '3';
		}
		if (isset($this->request->post['imgcolor'])) {
			$data['imgcolor'] = $this->request->post['imgcolor'];
		} elseif (!empty($module_info)) {
			$data['imgcolor'] = $module_info['imgcolor'];
		} else {
			$data['imgcolor'] = '#f8f8f8';
		}			
		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();

		$this->load->model('tool/image');

		if (isset($this->request->post['service'])) {
			$services = $this->request->post['service'];
		} elseif (isset($module_info['service'])) {
			$services = $module_info['service'];
		} else {
			$services = array();
		}

		$data['services'] = array();

		foreach ($services as $service) {
			if (is_file(DIR_IMAGE . $service['image'])) {
				$image = $service['image'];
				$thumb = $service['image'];
			} else {
				$image = '';
				$thumb = 'no_image.png';
			}

			$data['services'][] = array(
				'title'       => $service['title'],
				'other'        => $service['other'],
				'text'        => $service['text'],
				'image'       => $image,
				'thumb'       => $this->model_tool_image->resize($thumb, 100, 100),
				'sort_order'  => $service['sort_order']
			);
		}

		$data['placeholder'] = $this->model_tool_image->resize('no_image.png', 100, 100);

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/evaluation.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/evaluation')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 2) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}
		if (!$this->request->post['column']) {
			$this->error['column'] = $this->language->get('error_column');
		}
		return !$this->error;
	}
}